# Elcut       coil.pbm.

#===============================================
#   Elcut
#===============================================
function getELCForceX ($x_position)
	{
#0.  
#1.   ,  
#2.  


#0.  
	$ELC =  new-object -comobject ELCUT.Application	#  ELCUT
	$pbm = $ELC.Problems.Item(1)	#    
	$pbm.LoadModel() 				# 
	$mdl = $pbm.Model				#  
	
#1.      x,   "R" 
	$theVertex = $mdl.Shapes.Vertices.LabeledAs("R","","").Item(1)
	$theXposition = $theVertex.Point.X;	#  x  "R"
	$theVector = $ELC.PointXY($x_position - $theXposition, 0)	#  
#   2- : "" (), "" ()
#   ,      
	$theBlock = $mdl.Shapes.Blocks.LabeledAs("","","").Item(1)	#  ""
	$theBlock.Move(0, $theVector)		# . 0=qfCShift, 



#2.  
	$mdl.Shapes.BuildMesh($True,$False)	# 
	$mdl.Save();				# 	
	if (-Not($pbm.Solved))			#   , 
		{
		$pbm.SolveProblem()		# 
		};
	$pbm.AnalyzeResults()			# 
	$res = $pbm.Result			#   
    

	$theFieldWindow = $res.GetFieldWindow(1)#   
	$theContour = $theFieldWindow.Contour	#  
#   2- : "" (), "" ()
	$theContour.AddBlock1("")	#    ""
	$theContour.AddBlock1("")	#   a ""

#   
    	$theForce = $res.GetIntegral(15, $theContour).Value #15=qfInt_MaxwellForce
    	return $theForce.X			# x- 
	}

	

#===============================================
#    
#===============================================

#  
$x_out = 0.01       	#   , 
$x_in = 0.006       	#   , 
$m_mass = 0.0045     	#  , 
$k = 4.0            	#   , /
$x_spring_free = 0.015  	#    , 


# 
$t_time = 0.0    	# , 
$x_position = $x_out  	#  , 
$v_speed = 0.0         	#  , /


$dt_time_step = 0.005	#  , 
$max_time = 0.2        	#   


echo " []	 []	  [/]"

while (($t_time -lt $max_time) -and ($x_position -gt $x_in))
	{
	$theForce = getELCForceX($x_position)				#  
    # PowerShell      ,
    #     .
    #,  $theContour.AddBlock1     "TRUE",
	#        
    #        [-1] -   
    $theForceX = $theForce[-1]
    $theForceX = $theForceX + ($x_spring_free - $x_position) * $k	#   
    $v_speed += $theForceX / $m_mass * $dt_time_step 	#    
    $x_position += $v_speed * $dt_time_step		#   
	$t_time += $dt_time_step			#  
	echo "$t_time	$x_position	$v_speed"	#  
	}
